import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

import entities.Developer;

public class ComparatorTest {
	public static void main(String[] args) {

		List<Developer> listDevs = getDevelopers();

		System.out.println("Before Sort");
		for (Developer developer : listDevs) {
			System.out.println(developer);
		}

		System.out.println("After Sort");

		// lambda here!
		listDevs.sort((Developer o1, Developer o2) -> o1.getAge() - o2.getAge());

		// java 8 only, lambda also, to print the List
		listDevs.forEach((developer) -> System.out.println(developer));
		
		System.out.println("After Sort by name");

		// lambda here!
		listDevs.sort((Developer o1, Developer o2) -> o1.getName().compareTo(o2.getName()));

		// java 8 only, lambda also, to print the List
		listDevs.forEach(System.out::println);
	}

	private static List<Developer> getDevelopers() {

		List<Developer> result = new ArrayList<Developer>();

		result.add(new Developer("mike", new BigDecimal("70000"), 33));
		result.add(new Developer("alvin", new BigDecimal("80000"), 20));
		result.add(new Developer("jason", new BigDecimal("100000"), 10));
		result.add(new Developer("iris", new BigDecimal("170000"), 55));

		return result;

	}
}
